
$(document).ready(function() {
	
	$(".masquer").hide();
	$('#ladescription').html('<h3>Les bons mots</h3><p>Compléter chaque description en sélectionnant les mots correspondants.</p>');
	$(".score").hide();
	genererMenuJeu();
	afficherNbCartes();
	demarrerJeu();
	
	$("#valider").click(function(){
		$('select.leslistes').each(function(){
			var choix = $(this).val();
			var bonnereponse = $(this).parent().attr('data-reponse');
			if (choix == bonnereponse) {
				//alert('oui');
				juste ++;
				$("#juste").text(juste);
				$(this).parent().append($(this).val());
				$('.mot_juste').addClass('liste_juste');
				$(this).remove();
			}
			else {
				//alert('non');
				faux ++;
				$("#faux").text(faux);
				$(this).addClass('liste_faux');
			}
		});
		var limage = $('#lacarte img').attr('src');
		var desc_encours = $('#description_listes').html();
		var rech_select = desc_encours.search('</select>');
		if (rech_select == -1) {// s'il n'existe plus de balises </select>
			if (jeuEnCours.length != 1) { // s'il reste encore au moins une carte
				var cartes_restantes = nb_cartes_choisi;
				if (jeuEnCours.length == 2) cartes_restantes = 'un portrait à reconstituer...';
				if (jeuEnCours.length > 2) cartes_restantes = jeuEnCours.length-1+' portraits à reconstituer...';
				var voir_rep_juste = '<div><img style="float:left; margin-right:1em" src="'+limage+'"><div style="font-weight:bold; color:green">'+$('#description_listes').html()+'</div><div style="clear:both"></div>';
				$('#reponse').modal($('#lareponse').html(voir_rep_juste));
				$('#reponse').modal($('#lepouce').html('<img style="float:right" src="images/logo_pouce_juste.png"> Bravo !<br>Encore '+cartes_restantes));
				jeuEnCours.shift();
				afficherCarte();
			}
			else {
			//alert('terminé');
			$('#reponse').modal('hide');
			var compteur_fin = $('#compteur').text();
			var score_fin = $('#score').text();
			var pouce_haut = $('#juste').text();
			var pouce_bas = $('#faux').text();
			$('#jeu_termine').modal({backdrop:'static'});
			$('#jeu_termine').modal($('#felicitations').html('Félicitations ! <span style="float:right; margin-left:30px;"> '+pouce_bas+' <img src="images/logo_pouce_faux_32.png"></span><span style="float:right;">'+pouce_haut+' <img src="images/logo_pouce_juste_32.png"></span><br>Tu as réussi en '+compteur_fin+' avec un score de '+score_fin+'...<br>'));
			stopCount();
			}
		} 
		score = Math.round(juste*100/(juste+faux)) +'%';
		$("#score").text(score);
	});
	
	$("#rejouer").click(function(){
		$('#jeu_termine').hide();
		window.location.reload();
	});
	
	$('body').on('click', '.mot_faux', function () {
		lire($(this).text(),"fr-FR",1,1);
	});
	
}); // Fin $(document).ready(function()


	/* -------------------------------------------------------
	DECLARATION DES VARIABLES
	---------------------------------------------------------- */
	
	var synth = window.speechSynthesis;
	const mesSV = "Pour écouter le texte en synthèse vocale, connecter le poste à Internet et actualiser l'application.";
	var jeuEnCours = new Array();
	var jeu_selectionne = 0;
	var nb_cartes_choisi = 12;
	var compte = 0;
	var temps;
	var timer_is_on = 0;
	var compteur = 0;
	var juste = 0;
	var faux = 0;
	var score = 0;
	
	/* -------------------------------------------------------
	FONCTIONS
	---------------------------------------------------------- */
	
	function demarrerJeu() {
		$(".demarrer").change(function(){
			jeu_selectionne = $("#jeu_selectionne").val();
			nb_cartes_choisi = $("#choix_nb_cartes").val();
			if (jeu_selectionne != '') {
				$(".masquer").show();
				initialiserSerie();
				afficherCarte();
				initialiseCompteur();
			}
		});
	}
	
	function genererMenuJeu() {
		var listedesjeux = '<option value="">Choisis un jeu...</option>';
		for (var i=0; i < tableaudesjeux.length ; i++) {
			listedesjeux += '<option value="'+i+'">'+tableaudesjeux[i][0]+'</option>';
		}
		$("#jeu_selectionne").html(listedesjeux);
	}
	
	function afficherNbCartes() {
		var choix_nb_cartes = '';
		for (var i=10; i > 2 ; i--) {
			choix_nb_cartes += '<option value="'+i+'">'+i+'</option>';
		}		
		$("#choix_nb_cartes").html(choix_nb_cartes);
	}
		
	function initialiserSerie() {
		jeuEnCours = clone(tableaudesjeux[jeu_selectionne][1]);
		jeuEnCours.shuffle();
		jeuEnCours = jeuEnCours.slice(0,nb_cartes_choisi);
		for (var i=0; i < jeuEnCours.length ; i++) {
			jeuEnCours[i][0] = '<img class="img-responsive" style="margin:auto;" src="cartes/'+jeuEnCours[i][0]+'">';
		}
		$('#ladescription').html('<h3>Les bons mots</h3><p>Observe l\'image et sélectionne les mots qui la décrivent. Tu peux cliquer sur les mots pour les écouter.</p>');
	}
	
	function afficherCarte() {
		$('#lacarte').html('<div>'+jeuEnCours[0][0]+'</div>');
		var ladescription = jeuEnCours[0][1];
		var tabloavecpipe = new Array();
		tabloavecpipe = ladescription.split('|');
		var tabmot = new Array();
		for (var i=0; i < tabloavecpipe.length ; i++) {
			if (i%2 == 1) tabmot.push(tabloavecpipe[i]);// récupère les éléments pairs du tableau (les mots entre |)
		}
		tabmot.sort();
		var laliste='';
		laliste = '<select class="leslistes">';
		laliste += '<option value=""></option>';
		for (var i=0; i < tabmot.length ; i++) {
			laliste += '<option value="'+tabmot[i]+'">'+tabmot[i]+'</option>';
		}
		laliste += '</select>';
		for (var i=0; i < tabloavecpipe.length ; i++) {
			if (i%2 == 0) tabloavecpipe[i] = tabloavecpipe[i].replace(tabloavecpipe[i], '<span style="cursor:pointer;" title="Cliquer pour écouter..." class="mot mot_faux" data-reponse="">'+tabloavecpipe[i]+'</span>');
			if (i%2 == 1) tabloavecpipe[i] = tabloavecpipe[i].replace(tabloavecpipe[i], '<span class="mot mot_juste" data-reponse="'+tabloavecpipe[i]+'">'+laliste+'</span>');
		}
		ladescription = tabloavecpipe.join(' ');
		$('#description_listes').html(ladescription);
	}

	function initialiseCompteur() {
		compte = 0; // met le compteur à zéro
		startCount(); // démarre le compteur
		$("#compteur").text(); // affiche le compteur
		juste = 0;
		$("#juste").text(juste);
		faux = 0;
		$("#faux").text(faux);
		score = 0;
		$("#score").text('');
	}
	
	/* -----------------------------------------------------------
	Compteur
	--------------------------------------------------------------*/

	function timedCount() {
		var secondes=new Date();
		secondes.setTime(compte*1000);
		var lesMinutes = secondes.getMinutes();
		var lesSecondes = secondes.getSeconds();
		lesMinutes=lesMinutes.toString().replace(/^(\d)$/,'0$1')
		lesSecondes=lesSecondes.toString().replace(/^(\d)$/,'0$1')
		var compteur= lesMinutes+":"+lesSecondes;
		$("#compteur").text(compteur);
		compte = compte + 1;
		temps = setTimeout(function(){ timedCount() }, 1000);
	}

	function startCount() {
		if (!timer_is_on) {
			timer_is_on = 1;
			timedCount();
		}
	}

	function stopCount() {
		clearTimeout(temps);
		timer_is_on = 0;
	}
	
	/* -----------------------------------------------------------
	Mélanger les éléments d'un tableau
	http://fr.openclassrooms.com/forum/sujet/javascript-melanger-les-valeurs-d-un-array-80382
	--------------------------------------------------------------*/

	function randomInt(mini, maxi)
	{
		 var nb = mini + (maxi+1-mini)*Math.random();
		 return Math.floor(nb);
	}
	 
	Array.prototype.shuffle = function(n)
	{
		 if(!n)
			  n = this.length;
		 if(n > 1)
		 {
			  var i = randomInt(0, n-1);
			  var tmp = this[i];
			  this[i] = this[n-1];
			  this[n-1] = tmp;
			  this.shuffle(n-1);
		 }
	}
	
	/*   , */
	
	/* -----------------------------------------------------------
	Cloner un tableau en coupant le lien avec l'original 
	https://davidwalsh.name/javascript-clone
	--------------------------------------------------------------*/
	
	function clone(src) {
		function mixin(dest, source, copyFunc) {
			var name, s, i, empty = {};
			for(name in source){
				// the (!(name in empty) || empty[name] !== s) condition avoids copying properties in "source"
				// inherited from Object.prototype.	 For example, if dest has a custom toString() method,
				// don't overwrite it with the toString() method that source inherited from Object.prototype
				s = source[name];
				if(!(name in dest) || (dest[name] !== s && (!(name in empty) || empty[name] !== s))){
					dest[name] = copyFunc ? copyFunc(s) : s;
				}
			}
			return dest;
		}

		if(!src || typeof src != "object" || Object.prototype.toString.call(src) === "[object Function]"){
			// null, undefined, any non-object, or function
			return src;	// anything
		}
		if(src.nodeType && "cloneNode" in src){
			// DOM Node
			return src.cloneNode(true); // Node
		}
		if(src instanceof Date){
			// Date
			return new Date(src.getTime());	// Date
		}
		if(src instanceof RegExp){
			// RegExp
			return new RegExp(src);   // RegExp
		}
		var r, i, l;
		if(src instanceof Array){
			// array
			r = [];
			for(i = 0, l = src.length; i < l; ++i){
				if(i in src){
					r.push(clone(src[i]));
				}
			}
			// we don't clone functions for performance reasons
			//		}else if(d.isFunction(src)){
			//			// function
			//			r = function(){ return src.apply(this, arguments); };
		}else{
			// generic objects
			r = src.constructor ? new src.constructor() : {};
		}
		return mixin(r, src, clone);
	}

function lire(texte,lang,rate,pitch) {
	if (texte !== '' && !synth.speaking) {
		// alert("pitch ou prodosie : "+pitch+"\nrate ou débit : "+rate);
		var utterThis = new SpeechSynthesisUtterance(texte);
		utterThis.onend = function (event) {
			// console.log('SpeechSynthesisUtterance.onend');
		};
		utterThis.onerror = function (event) {
			// console.error('SpeechSynthesisUtterance.onerror');
		};
		utterThis.lang = lang;
		utterThis.rate = rate;// débit
		utterThis.pitch = pitch;// prodosie
		synth.speak(utterThis);
	} else synth.cancel();
}